﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using ImageLibrary;

namespace Dg_DesktopApp {
	public partial class Dg_DesktopApp : Form {

		private List<string> fileNameList = new List<string>();
		private string destinationFolder = null;

		public Dg_DesktopApp() {
			InitializeComponent();
		}

		private void selectFilesButton_Click(object sender, EventArgs e) {
			processButton.Enabled = false;
			this.Update();
			DialogResult dr = selectFilesDialog.ShowDialog();
			if (dr == DialogResult.OK) {
				foreach (var photoFileName in selectFilesDialog.FileNames) {
					fileNameList.Add(photoFileName);
				}
			}
			selectFilesButton.Enabled = false;
			setDestinationButton.Enabled = true;
		}

		private void setDestinationButton_Click(object sender, EventArgs e) {
			DialogResult dr = destinationBrowserDialog.ShowDialog();
			if (dr == DialogResult.OK) {
				destinationFolder = destinationBrowserDialog.SelectedPath;
			}
			setDestinationButton.Enabled = false;
			processButton.Enabled = true;
		}

		private void processButton_Click(object sender, EventArgs e) {
			var flipper = new PhotoFlipper();
			var thumber = new PhotoThumbnailer();

			foreach (var filePath in fileNameList) {
				var fileName = String.Format("Processed_{0}", Path.GetFileName(filePath));
				var destinationFilePath = Path.Combine(destinationFolder, fileName);
				using (var inputStream = File.OpenRead(filePath)) {
					using (var outputStream = new FileStream(destinationFilePath, FileMode.Create)) {
						using (var interimStream = new MemoryStream()) {

							thumber.ProcessBitmapStream(inputStream, interimStream);
							inputStream.Flush();
							inputStream.Close();

							flipper.ProcessBitmapStream(interimStream, outputStream);
							interimStream.Flush();
							interimStream.Close();

							outputStream.Flush();
							outputStream.Close();
						}
					}
				}
			}

			selectFilesButton.Enabled = true;
			processButton.Enabled = false;
		}
	}
}
