﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using ImageLibrary;

namespace CloudLibrary {
	public abstract class BlobProcessor : QueueListener {
		public BitmapProcessorBase BitmapProcessor { get; set; }

		protected string _blobName;

		protected override void ProcessMessage(string blobName) {
			_blobName = blobName;

			using (var outputStream = new MemoryStream()) {
				using (var inputStream = new MemoryStream()) {
					BlobUtils.DownloadStreamFromBlob(ConnectionName, inputStream, BlobContainerName, blobName);

					ProcessBlobStream(inputStream, outputStream);

					BlobUtils.UploadStreamToBlob(ConnectionName, outputStream, BlobContainerName, blobName);

					inputStream.Flush();
					inputStream.Close();

					outputStream.Flush();
					outputStream.Close();
				}
			}
		}

		protected virtual void ProcessBlobStream(MemoryStream inputStream, MemoryStream outputStream) {
			BitmapProcessor.ProcessBitmapStream(inputStream, outputStream);
		}
	}
}
