﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

using CloudLibrary;

namespace FlipperProgram {
	class Program {
		private static readonly CancellationTokenSource cancellationTokenSource = new CancellationTokenSource();

		private static string inputQueue = "dg-flipper-queue";
		private static string outputQueue = "dg-ready-queue";
		private static string connectionName = "DgStorageConnection";
		private static string blobContainerName = "dgdemoblobcontainer";
		private static QueueListener processor;

		static void Main(string[] args) {
			processor = new FlipperProcessor();
			processor.ConnectionName = connectionName;
			processor.InputQueueName = inputQueue;
			processor.OutputQueueName = outputQueue;
			processor.BlobContainerName = blobContainerName;

			var queueTask = processor.WatchQueueAsync(cancellationTokenSource.Token);

			Console.ReadLine();
			cancellationTokenSource.Cancel();
			queueTask.Wait();
        }
	}
}
