﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Drawing.Imaging;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ImageLibrary {
	public abstract class BitmapProcessorBase {
		public virtual void ProcessBitmapStream(Stream inputStream, Stream outputStream) {
			inputStream.Position = 0;
			using (var bmp = new Bitmap(inputStream)) {
				outputStream.Position = 0;
				var resultBitmap = applyBitmapTransform(bmp);
				resultBitmap.Save(outputStream, ImageFormat.Jpeg);
				outputStream.Position = 0;
			}
		}

		protected abstract Bitmap applyBitmapTransform(Bitmap bmp);
	}
}
