﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using CloudLibrary;

namespace UploaderProgram {
	public partial class Dg_DesktopApp : Form {

		private List<string> fileNameList = new List<string>();
		private string destinationFolder = null;
		private string outputQueue = "dg-thumbnailer-queue";
		private string connectionName = "DgStorageConnection";
		private string blobContainerName = "dgdemoblobcontainer";

		public Dg_DesktopApp() {
			InitializeComponent();
		}

		private void selectFilesButton_Click(object sender, EventArgs e) {
			processButton.Enabled = false;
			this.Update();
			fileNameList.Clear();
			DialogResult dr = selectFilesDialog.ShowDialog();
			if (dr == DialogResult.OK) {
				foreach (var photoFileName in selectFilesDialog.FileNames) {
					fileNameList.Add(photoFileName);
				}
			}
			selectFilesButton.Enabled = false;
			processButton.Enabled = true;
		}

		private void processButton_Click(object sender, EventArgs e) {
			foreach (var filePath in fileNameList) {
				var blobName = Path.GetFileName(filePath);
				using (var inputStream = File.OpenRead(filePath)) {
					var blob = BlobUtils.UploadStreamToBlob(connectionName, inputStream, blobContainerName, blobName);
					queueBlobAddress(blobName, outputQueue);
					inputStream.Flush();
					inputStream.Close();
				}
			}

			selectFilesButton.Enabled = true;
			processButton.Enabled = false;
		}

		private string uploadToBlob(Stream inputStream, string blobName) {
			var blobAddr = String.Empty;
			return blobAddr;
		}

		private void queueBlobAddress(string blobAddr, string queueName) {
			QueueUtils.EnqueueString(connectionName, queueName, blobAddr);
		}
	}
}
