﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Web;
using System.Web.Mvc;

using Dg_WebApp.Models;
using CloudLibrary;

namespace Dg_WebApp.Controllers {
	public class HomeController : Controller {
		private string outputQueue = "dg-thumbnailer-queue";
		private string connectionName = "DgStorageConnection";
		private string blobContainerName = "dgdemoblobcontainer";

		public ActionResult Index() {
			return View();
		}

		public ActionResult About() {
			ViewBag.Message = "Your application description page.";

			return View();
		}

		public ActionResult Contact() {
			ViewBag.Message = "Your contact page.";

			return View();
		}

		[HttpPost]
		public ActionResult Index(HttpPostedFileBase file) {
			var blobName = Path.GetFileName(file.FileName);
			// Upload file
			using (var inputStream = file.InputStream) {
				BlobUtils.UploadStreamToBlob(connectionName, inputStream, blobContainerName, blobName);
				inputStream.Flush();
				inputStream.Close();
			}

			// Pass into the "Thumbnail-Flip" process flow
			queueBlobAddress(blobName, outputQueue);

			return RedirectToAction("Index");
		}

		public ActionResult Images() {
			var imagesModel = new ImageViewModel();

			var container = BlobUtils.EnsureContainer(connectionName, blobContainerName);
			var blobList = container.ListBlobs();
			var urlList = container.ListBlobs().Select(u => u.Uri.AbsoluteUri);

			imagesModel.ImageUrls.AddRange(urlList);

			return View(imagesModel);
		}

		private void queueBlobAddress(string blobAddr, string queueName) {
			QueueUtils.EnqueueString(connectionName, queueName, blobAddr);
		}
	}
}